
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>更改Oracle实例的字符集 / iVAN</title>

    <meta name="description" content="更改Oracle实例的字符集 (1).数据库服务器字符集select * from nls_database_parameters 来源于props$,是表示数据库的字符集. (2).服务端字符集环境select * from nls_instance_parameters 其来源于v$parameter,表示服务端的字符集的设置,可能是参数文件,环境变量或者是注册表 (3).会话字符集环境select * from nls_session_parameters 来源于v$nls_parameters,表示会话自己的设置,可">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">更改Oracle实例的字符集</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>(1).数据库服务器字符集<br />select * from nls_database_parameters</p>
<p>来源于props$，是表示数据库的字符集。</p>
<p>(2).服务端字符集环境<br />select * from nls_instance_parameters</p>
<p>其来源于v$parameter，表示服务端的字符集的设置，可能是参数文件，环境变量或者是注册表</p>
<p>(3).会话字符集环境<br />select * from nls_session_parameters</p>
<p>来源于v$nls_parameters，表示会话自己的设置，可能是会话的环境变量或者是alter session完成，如果会话没有特殊的设置，将与nls_instance_parameters一致。</p>
<p> (4).客户端的字符集要求与服务器一致，才能正确显示数据库的非Ascii字符。</p>
<p>如果多个设置存在的时候，NLS作用优先级别：Sql function &gt; alter session &gt; 环境变量或注册表 &gt; 参数文件 &gt; 数据库默认参数</p>
<p>字符集要求一致，但是语言设置却可以不同，语言设置建议用英文。如字符集是zhs16gbk，则nls_lang可以是American_America.zhs16gbk。</p>
<p><strong>客户端字符集设置方法</strong><br />1)UNIX环境<br />         $NLS_LANG=“simplified chinese”_china.zhs16gbk<br />         $export NLS_LANG<br />         编辑oracle用户的profile文件<br />2)Windows环境<br />编辑注册表<br />Regedit.exe ---》 HKEY_LOCAL_MACHINE ---》SOFTWARE ---》 ORACLE-HOME<br />或者在窗口设置：<br />set nls_lang=AMERICAN_AMERICA.ZHS16GBK<br />http://blog.itpub.net/8475224/viewspace-692675/</p>
<p>NLS_LANG格式：<br />NLS_LANG = language_territory.charset<br />有三个组成部分（语言、地域和字符集），每个成分控制了NLS子集的特性。其中：<br />language 指定服务器消息的语言。<br />territory 指定服务器的日期和数字格式。<br />charset 指定字符集<br />从NLS_LANG的组成我们可以看出，真正影响数据库字符集的其实是第三部分。<br />所以两个数据库之间的字符集只要第三部分一样就可以相互导入导出数据，前面影响的只是提示信息是中文还是英文。</p>
<p>字符集<br />实质就是按照一定的字符编码方案，对一组特定的符号，分别赋予不同数值编码的集合。Oracle数据库最早支持的编码方案是US7ASCII。<br />Oracle的字符集命名遵循以下命名规则:<br />即: &lt;语言&gt;&lt;比特位数&gt;&lt;编码&gt;<br />比如: ZHS16GBK表示采用GBK编码格式、16位（两个字节）简体中文字符集<br />http://blog.itpub.net/8475224/viewspace-692675/</p>
<p>例如：<br />AMERICAN_AMERICA.US7SCII<br />AMERICAN _ AMERICA. ZHS16GBK<br />只显示了语言信息，是因为数据库安装时默认使用OS的地域和字符集。<br />安装Oracle的时候不是有个显示字符集选择的步骤吗，那个时候安装程序自己就带出了一个OS的字符集作为默认选择，当然你可以更改的。<br />select * from <strong>nls_session_parameters</strong>;<br />更改Oracle实例的字符集（服务器端）：</p>
<pre>--SIMPLIFIED CHINESE_CHINA.ZHS16GBK
--=&lt;Language&gt;_&lt;Territory&gt;.&lt;Clients Characterset&gt;
select t.name,t.value$,t.rowid from sys.props$  t where name='NLS_LANGUAGE' or name='NLS_CHARACTERSET' or name like 'NLS_TERRITORY';</pre>
<p>具体更改情况参考以下update语句：</p>
<pre>update sys.props$ set value$='SIMPLIFIED CHINESE'  where name='NLS_LANGUAGE';
commit;
update sys.props$ set value$='ZHS16GBK' where name='NLS_CHARACTERSET' ;
commit;
update sys.props$ set value$='CHINA'  where name='NLS_TERRITORY';
commit;</pre>
<p>如果更改后没有立即生效，重启此实例。</p>
<p> </p>
<p>查看服务器端字符集：<br />select * from v$nls_parameters;<br />select * from nls_database_parameters;<br />select * from sys.props$;</p>
<p> </p>
<p><a href="http://www.linuxidc.com/Linux/2010-03/24767.htm" rel="external nofollow noreferrer">http://www.linuxidc.com/Linux/2010-03/24767.htm</a></p>
<p> </p>
<p>在做ETL的时候，经常有一些字段提示长度不够。今天偶抓住一张表来分析了一下，后来发现中文在不同字符集所占用的字节是不同的。详细如下：</p>
<p>源数据库字符集为: ZHS16GBK，数据仓库的字符集为：UTF-8</p>
<p>查询字符集：<br />SELECT * FROM DATABASE_PROPERTIES WHERE property_name = 'NLS_CHARACTERSET'</p>
<p>源数据库：（ZHS16GBK）</p>
<p>SQL&gt; SELECT '中文', length('中文') x, lengthb('中文') xb FROM dual;<br />  '中文'          X         XB <br />------ ---------- ---------- <br />中文            2          4</p>
<p>目标数据库：（UTF8）</p>
<p>SQL&gt; SELECT '中文', length('中文') x, lengthb('中文') xb FROM dual; <br /> '中文'                X         XB <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />------------ ---------- ---------- <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />中文                  2          6</p>
<p> </p>
<p>做了一个表测试了一下：</p>
<p>在源数据库里：</p>
<p>SQL&gt; create table cntable(fname varchar2(4)); <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />Table created  <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />SQL&gt; insert into cntable(fname) values('张三');  <br />1 row inserted <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"></p>
<p>在目标数据仓库里：</p>
<p>SQL&gt; create table cntable(fname varchar2(4)); <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />Table created <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />SQL&gt; insert into cntable(fname) values('张三'); <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />insert into cntable(fname) values('张三') <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"><br />ORA-12899: value too large for column "HUB"."CNTABLE"."FNAME" (actual: 6, maximum: 4) <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hNjMzOWVlM2U1N2QxZDUyYmM3ZDAyYjMzOGUxNWE2MC5naWY=.jpg"></p>
<p> </p>
<p>很显然中文在UTF8里占3个字节，ZHK里占2个字节。</p>
<p>备注：</p>
<h3>Purpose</h3>
<p>The LENGTH functionsreturn the length of char. LENGTH calculates length usingcharacters as defined by the input character set.</p>
<p>     --返回以字符为单位的长度.</p>
<p>LENGTHB usesbytes instead of characters.</p>
<p>     --返回以字节为单位的长度.</p>
<p>LENGTHC usesUnicode complete characters.</p>
<p>     --返回以Unicode完全字符为单位的长度.</p>
<p>LENGTH2 usesUCS2 code points.</p>
<p>     --返回以UCS2代码点为单位的长度.</p>
<p>LENGTH4 usesUCS4 code points.</p>
<p>    --返回以UCS4代码点为单位的长度.</p>
<p>在不同的数据库，因为字符集的不同，LENGTHB得到的值可能会不一样。如ZHS16GBK采用两个byte位来定义一个汉字。而在UTF8，采用3个byte。</p>
<p>SYS@anqing1(rac1)&gt; SELECT USERENV('LANGUAGE') FROM DUAL;</p>
<p>USERENV('LANGUAGE')</p>
<p>----------------------------------------------------</p>
<p>AMERICAN_AMERICA.ZHS16GBK</p>
<p>SQL&gt;select length('安庆') from dual;</p>
<p>2</p>
<p>SQL&gt;select lengthb('安庆') from dual;</p>
<p>4</p>
<p>SQL&gt;select length('AnQing') from dual;</p>
<p>6</p>
<p>SQL&gt;select lengthb('AnQing') from dual;</p>
<p>6</p>
<p>通过这个示例，我们可以看出来，Length 和 Lengthb 函数的一个重要用处，就是用来判断记录值里是否有中文内容。</p>
<p>如果有中文，那么Length() != Lengthb()</p>
<p>如果没有中文，那么Length() == Lengthb()</p>
<p><a href="http://blog.csdn.net/tianlesoftware/article/details/6863797" rel="external nofollow noreferrer">http://blog.csdn.net/tianlesoftware/article/details/6863797</a></p>
<p> </p>
<p>USEREVN -- 官方文档 functions228.htm#i79862<br />Oracle建议用  sys_context 来代替 userenv</p>
<p>USERENV('DB_NAME')  《--------》SYS_CONTEXT('USERENV','DB_NAME');</p>
<p>返回当前用户环境&lt;也就是sqlplus 所在电脑的环境&gt;的信息,opt可以是:<br />ENTRYID,SESSIONID,TERMINAL,ISDBA,LABLE,LANGUAGE,CLIENT_INFO,LANG,VSIZE</p>
<p><strong>USEREVN()</strong></p>
<p>1.ISDBA   查看当前用户是否是DBA如果是则返回true</p>
<p>SQL&gt; select userenv('isdba') from dual;</p>
<p>USEREN<br />------<br />FALSE</p>
<p>2.SESSION 返回会话标志</p>
<p>SQL&gt; select userenv('sessionid') from dual;</p>
<p>USERENV('SESSIONID')<br />--------------------<br />152</p>
<p>4.ENTRYID 返回会话人口标志</p>
<p>SQL&gt; select userenv('entryid') from dual;</p>
<p>USERENV('ENTRYID')<br />------------------<br />0</p>
<p>5.INSTANCE 返回当前INSTANCE的标志<br />SQL&gt; select userenv('instance') from dual;</p>
<p>USERENV('INSTANCE')<br />-------------------<br />1</p>
<p>6.LANGUAGE 返回当前环境变量<br />SQL&gt; select userenv('language') from dual;</p>
<p>USERENV('LANGUAGE')<br />----------------------------------------------------<br />SIMPLIFIED CHINESE_CHINA.ZHS16GBK</p>
<p>7.LANG 返回当前环境的语言的缩写<br />SQL&gt; select userenv('lang') from dual;</p>
<p>USERENV('LANG')<br />----------------------------------------------------<br />ZHS</p>
<p>8.TERMINAL 返回用户的终端或机器的标志<br />SQL&gt; select userenv('terminal') from dual;</p>
<p>USERENV('TERMINA<br />----------------<br />GAO</p>
<p>9.VSIZE(X) 返回X的大小(字节)数<br />SQL&gt; select vsize(user),user from dual;</p>
<p>VSIZE(USER) USER<br />----------- ------------------------------<br />6 SYSTEM</p>
<pre>select 　　SYS_CONTEXT('USERENV', 'DB_NAME') db_name,
       　　SYS_CONTEXT('USERENV', 'CURRENT_USER') current_user,
       　　SYS_CONTEXT('USERENV', 'LANGUAGE') language,

       　　SYS_CONTEXT('USERENV', 'OS_USER') os_user,
       　　SYS_CONTEXT('USERENV', 'TERMINAL') terminal,
       　　SYS_CONTEXT('USERENV', 'SESSIONID') sessionid,
       　　SYS_CONTEXT('USERENV', 'INSTANCE') instance,
       　　SYS_CONTEXT('USERENV', 'ENTRYID') entryid,
       　　SYS_CONTEXT('USERENV', 'ISDBA') isdba,
       　　SYS_CONTEXT('USERENV', 'NLS_TERRITORY') nls_territory,
       　　SYS_CONTEXT('USERENV', 'NLS_CURRENCY') nls_currency,
       　　SYS_CONTEXT('USERENV', 'NLS_CALENDAR') nls_calendar,
       　　SYS_CONTEXT('USERENV', 'NLS_DATE_FORMAT') nls_date_format,
       　　SYS_CONTEXT('USERENV', 'NLS_DATE_LANGUAGE') nls_date_language,
       　　SYS_CONTEXT('USERENV', 'NLS_SORT') nls_sort,

       　　SYS_CONTEXT('USERENV', 'CURRENT_USERID') current_userid,
       　　SYS_CONTEXT('USERENV', 'SESSION_USER') session_user,
       　　SYS_CONTEXT('USERENV', 'SESSION_USERID') session_userid,
       　　SYS_CONTEXT('USERENV', 'PROXY_USER') proxy_user,
       　　SYS_CONTEXT('USERENV', 'PROXY_USERID') proxy_userid,
       　　SYS_CONTEXT('USERENV', 'DB_DOMAIN') db_domain,
       　　SYS_CONTEXT('USERENV', 'HOST') host,
       　　SYS_CONTEXT('USERENV', 'EXTERNAL_NAME') external_name,
       　　SYS_CONTEXT('USERENV', 'IP_ADDRESS') ip_address,
       　　SYS_CONTEXT('USERENV', 'NETWORK_PROTOCOL') network_protocol,
       　　SYS_CONTEXT('USERENV', 'BG_JOB_ID') bg_job_id,
       　　SYS_CONTEXT('USERENV', 'FG_JOB_ID') fg_job_id,
       　　SYS_CONTEXT('USERENV', 'AUTHENTICATION_TYPE') authentication_type,
       　　SYS_CONTEXT('USERENV', 'AUTHENTICATION_DATA') authentication_data 　　from dual;</pre>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 05:52:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/update/" title="update">update</a>, <a href="https://www.iamivan.net/tag/%e5%ad%97%e7%ac%a6%e9%9b%86/" title="字符集">字符集</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e4%bb%93%e5%ba%93/" title="数据仓库">数据仓库</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>更改Oracle实例的字符集的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqaZ6ZM.html" rel="bookmark">Oracle数据库的字符集更改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle数据库的字符集更改 A.oracle server 端 字符集查询  select userenv('language') from dual 其中NLS_CHARACTERSET 为server端字符集  NLS_LANGUAGE 为 server端字符显示形式    B.查询oracle client端的字符集   $echo $NLS_LANG  如果发现你select 出来的数据是乱码,请把client端的字符集配置成与linux操作系统相同的字符集.如果还是有乱码,则有可能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK7KeZb.html" rel="bookmark">Oracle实例和Oracle数据库概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于初接触Oracle 数据库的人来讲,很容易混淆的两个概念即是Oracle 实例和Oracle 数据库.这两概念不同于SQL sever下的实例与数据库,当然也有些相似之处.只是在SQL server我们根本不需要花费太多的精力去搞清SQL实例和数据库,因为它简单易于理解.下面简要说明一下SQL实例.数据库,更多的是讲述Oracle下的实例及数据库. 一.SQL server中的实例与数据库 1.SQL中的实例指的是一个SQL server服务器上仅有一个缺省实例.缺省实例名即为机器名Serv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ox9Ab.html" rel="bookmark">Oracle实例恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle实例恢复原理 首先从事物说起,当执行update开启一个事物的时候,首先需要在buffer cache中找到可用的块(block)更新数据,然后构造cr块,将update之前的数据放入到undo中,同时会在log buffer内写日志,log buffer内数据每隔3秒通过lgwr进程将往redo log写日志,在这个过程更改的数据还在内存中,产生脏数据,直到dbwr进程将脏数据写入到磁盘,如果脏数据还未写入磁盘,脏数据中包括提交或未提交的,这个时候由于掉掉或其他原因导致数据库意外宕			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7xm2Xb.html" rel="bookmark">Oracle实例和Oracle数据库&lpar;Oracle体系结构&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--========================================== --Oracle实例和Oracle数据库(Oracle体系结构) --========================================== /*     对于初接触Oracle 数据库的人来讲,很容易混淆的两个概念即是Oracle 实例和Oracle 数据库.这两 概念不同于SQL sever下的实例与数据库,当然也有些相似之处.只是在SQL server我们根本不需要花费太 多的精力去搞清			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLm0Kb.html" rel="bookmark">windows 7上如何更改oracle 11g的归档模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在win7上更改oracle 11g的归档模式,描述包括可能遇到的错误,这些错误也是写这篇博文的初衷,就是为了让其它通道避免同样的错误,或者碰到同样的错误指导如何解决,因为命令已经很清楚,所以就不详细解释. SQL&gt; conn sys/oracle@osid as sysdba 已连接. SQL&gt; select instance_name from V$instance; INSTANCE_NAME -------------------------------- osid SQL&gt; a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myr1vdp.html" rel="bookmark">Oracle实例恢复概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Oracle实例失败 Oracle实例失败多为实例非一致性关闭所致,通常称为崩溃(crash).实例失败的结果等同于shutdown abort. 实例失败的原因 电源负载故障 硬件故障 后台进程失败 异常关闭数据库 实例失败后的状况 数据库可能丢失已提交的事务以及存储了未提交的事务,导致数据库出现不一致的情况 解决方案 使用startup 重新启动实例.实例实现自动恢复,根据联机日志文件前滚提交的事务,回滚未提交的事务 查看告警日志.跟踪日志等找出出现故障的原因 二.检查点 检查点在体系结			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLN0kb.html" rel="bookmark">ORACLE实例分享：DB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.修改数据库名 1.查看oracle实例名 2.shutdown immediate 3.lsnrctl stop $ORACLE_SID#----------windows下关闭使用oracle服务 4.修改 /etc/oratab 的$ORACLE_SID#------------windows没有 5.修改用户环境变量.bashprofile  #------------windows没有 6.linux下$ORACLE_HOME/dbs 修改有关$ORACLE_SID的文件名   wi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkWB8b.html" rel="bookmark">使用OEM&comma;SQL&ast;Plus&comma;iSQL&ast;Plus 管理Oracle实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--========================================== --使用OEM,SQL*Plus,iSQL*Plus 管理Oracle实例 --========================================== /* 一.管理组件     Oracle 10g数据库管理包含三个组件,本文主要介绍Database Control,SQL*Plus及iSQL*Plus        Database instance(数据库实例)  --&gt;系统使用的后台进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmJ61b.html" rel="bookmark">oracle 中文 乱码-oracle 客户端配置字符集问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 oracle 客户端配置字符集问题 通过SQL&gt;select userenv('language') from dual;查询到字符集是:AMERICAN _ AMERICA. ZHS16GBK通过select nls_charset_name(to_number('0354''xxxx')) from dual;查询到字符集是:ZHS16GBKoracle client客户端字符集是AMERICAN _ AMERICA. ZHS16GBK.为什么在数据库中插入insert into			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlLwLM.html" rel="bookmark" class="title">HBase使用场景和成功案例</a>
					<div>
						有时候了解软件产品的最好方法是看看它是怎么用的.它可以解决什么问题和这些解决方案如何适用于大型应用架构,能够告诉你很多.因为HBase有许多公开的产品部署,我们正好可以这么做.本章节将详细介绍一些人们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKW26p.html" rel="bookmark" class="title">MetaModel：跨多种数据存储提供统一的数据访问</a>
					<div>
						最近,Human Inference和Apache软件基金会(ASF)分别宣布了捐赠与接受MetaModel项目的消息, 今后MetaModel将成为一个Apache孵化器项目.此前,MetaMode ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7Y8db.html" rel="bookmark" class="title">利用Linux系统IP伪装防攻击</a>
					<div>
						防火墙可分为几种不同的安全等级.在Linux中,由于有许多不同的防火墙软件可供选择,安全性可低可高,最复杂的软件可提供几乎无法渗透的保护能力.不过,Linux核心本身内建了一种称作&quot;伪装&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPk3wz.html" rel="bookmark" class="title">一起学Windows Phone7开发&lpar;十三&period;二 按钮控件&rpar;</a>
					<div>
						在Silverlight中有多种按钮控件,这些控件在Windows phone7中也都得到了很好的支持. 一.Button:这个控件只是一个基础控件,通过blend可以创建出多种效果的按钮来. &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P42mM.html" rel="bookmark" class="title">iOS中点击按钮修改文本的尺寸</a>
					<div>
						 创建UILabel self.lbl=[[UILabel alloc] initWithFrame:CGRectMake(135, 290,200,35)]; self.lbl.background ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2AAdb.html" rel="bookmark" class="title">阿里云如何使用安全组相关接口</a>
					<div>
						创建安全组 描述 新建一个安全组,通过安全组防火墙规则配置实现对一组实例的防火墙配置.一个安全组可包含多个实例. 新建的安全组,默认只打开组内实例之间的访问权限,其他访问权限全部关闭.若用户允许其他组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRygeGb.html" rel="bookmark" class="title">修改Excel表格自动保存默认路径</a>
					<div>
						在Excel中常常处理完表格以后少不了将它们保存起来,但是Excel自动保存路径又不是自己理想的位置,每次都要选择保存的路径,如果能将这个步骤减去,直接保存到自己想要的路径就好了.这个问题不难,其实在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4JrAp.html" rel="bookmark" class="title">PHP扩展开发入门教程</a>
					<div>
						 这篇文章主要介绍了PHP扩展开发入门教程,本文讲解了使用C语言在Linux系统下开发一个PHP扩展应该具备的最基本知识,需要的朋友可以参考下     PHP扩展开发 我准备在此系列博文中总结我有关P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7R7xM.html" rel="bookmark" class="title">Word2007页码样式的制作</a>
					<div>
						  在编辑一篇长文档的时候,常常会在文档上设置页码,除了在页眉页脚上设置,还可以通过Word2007自带的页码样式进行选择.但是自带的样式不多,想要找到自己需要的样式,该如何操作呢? 比如我现在Wor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8BErp.html" rel="bookmark" class="title">PS如何修复严重受损的人像照片？</a>
					<div>
						  我们以这幅图片为例: 整体看来,原图的画质损失非常厉害,色彩过渡不自然,色阶丢失,噪点很多. 我们再看一下细节: 可以看到,面部的阴影区域已经达到了不可用的级别了,并且天空的画质损失也非常严重.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3VJWp.html" rel="bookmark" class="title">U大师如何一键智能装机？</a>
					<div>
						1.运行&quot;电脑版一键备份还原系统.exe&quot;文件,打开之后点击&quot;一键智能装机&quot;.(需要有GHO装机文件才能操作.) 2.在弹出的提示框选择对应的GHO文件,再选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw5Bqp.html" rel="bookmark" class="title">怎样更换自己的外网IP？</a>
					<div>
						  由于IPV4地址的稀缺,一般家庭用户和小公司都是共享同一个外网IP,外网IP与本地的IP不同,一个很简单的查看外网IP的办法就是打开百度,直接搜索&quot;IP地址&quot;便能查看到您所在网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr4mXp.html" rel="bookmark" class="title">cocoa touch-转码mp3格式时显示进度条。</a>
					<div>
						问题描述 转码mp3格式时显示进度条. 使用 LAME 将.caf音频文件编码为.mp3文件. 只有一个问题,需要计算转换文件的时间,用UIProgressView给用户显示转换进度,这点实现不了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwgwmb.html" rel="bookmark" class="title">linux c语言 使用system echo把变量输出到文件中</a>
					<div>
						问题描述 linux c语言 使用system echo把变量输出到文件中 #include #include #include int main(void) { char *url = &quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEXv2z.html" rel="bookmark" class="title">JavaScript&mdash;&mdash;数据类型</a>
					<div>
						ECMAScript有5种基本数据类型Undefined ,Null ,Boolean ,Number ,String 和一种复杂类型 Object 1. Undefined  Undefined类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Yq44M.html" rel="bookmark" class="title">Android学习笔记&lpar;22&rpar;&colon;AdapterView与Adapter</a>
					<div>
						AdapterView继承自ViewGroup,是一个抽象基类,作为容器使用,容器内是多个列表项,列表项有相似的形式,列表项的内容由Adapter提供.调用AdapterView的setAdapter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze63ljb.html" rel="bookmark" class="title">super-为什么子类重写父类方法之后还要调用父类同名方法</a>
					<div>
						问题描述 为什么子类重写父类方法之后还要调用父类同名方法 为什么子类重写父类方法之后还要调用父类同名方法 比如public class A extends B { public void say (  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYKPWp.html" rel="bookmark" class="title">女儿半夜起来上网偷好友&OpenCurlyDoubleQuote;菜&rdquo;急坏母亲</a>
					<div>
						新华网呼和浩特7月31日电(李富.红博)近来,网络上流行这样一个小游戏,只要在网站上注册一个账号,加上很多 网友,就可以在这个网站上种菜.养动物.打工等,还可以去偷好友的&quot;菜&quot;&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmoB1b.html" rel="bookmark" class="title">Chrome 官方扩展中心竟出现提供 NOD32 注册码的扩展</a>
					<div>
						Chrome 官方扩展中心最近上线了一个叫做 ESET Key http://www.aliyun.com/zixun/aggregation/2479.html&quot;&gt;Finder 的扩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy8dXz.html" rel="bookmark" class="title">GMIC 2014首日：智能机器人成亮点</a>
					<div>
						5月5日晚间消息,全球移动互联网大会(GMIC)2014今日在北京开幕.尽管&quot;下一个50亿&quot;是本届大会的主题,但智能机器人才是首日GMIC主会场的最大亮点:而整个大会期间既有对自身 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqo0xb.html" rel="bookmark" class="title">求助：如何用C语言编程获取证书中的RSA公钥？</a>
					<div>
						问题描述 如何用C语言编程获取证书中的RSA公钥,然后用RSA公钥对会话密钥加密后进行传输呢?CertOpenStoreCertFindCertificateInStore这些函数是包含在哪个头文件中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJgXkp.html" rel="bookmark" class="title">matlab对excel文件的导入和处理办法</a>
					<div>
						问题描述 matlab对excel文件的导入和处理办法 怎么使用matlab对一个文件下的多个文件夹中的excel文件进行导入和各种操作? 解决方案 http://wenku.baidu.com/li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk6gkM.html" rel="bookmark" class="title">objectdatasource 绑定后，gridview编辑列时，不能刷新</a>
					<div>
						问题描述 用objectdatasource绑定数据源后,gridview编辑列时,不能刷新:绑定数据库时,绑定的那张表里面只有三个字段.现在又添加了几个字段进去,但是gridview控件却不刷新了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWAWez.html" rel="bookmark" class="title">《Python 3程序开发指南（第2版&bull;修订版）》&mdash;&mdash;2&period;7 练习</a>
					<div>
						2.7 练习 1．修改程序print_unicode.py,以便用户可以在命令行上输入几个单独的单词,并且只有在Unicode字符名包含用户指定的所有单词时才打印相应列.这意味着,我们可以输入类似于如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44e11z.html" rel="bookmark" class="title">IOS提醒用户重新授权打开定位功能&lowbar;IOS</a>
					<div>
						iOS 8及以上版本最不为人知的一个特点是与应用设置的深层链接,用户可以根据APP的需要授权启用位置.通知.联系人.相机.日历以及健康等设置. 大多数应用程序仅仅是弹出一个包含操作指令的警示窗口,如& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkq5rp.html" rel="bookmark" class="title">随机数异常</a>
					<div>
						问题描述 import java.util.*;public class test {public static void main(String[] args) {for (int i = 0; i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1DRlM.html" rel="bookmark" class="title">怎样让百度快速收录的新方法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 怎样让百度快速收录的新方法 百度从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqynwb.html" rel="bookmark" class="title">exception-求大神帮忙啊，看看这是咋回事</a>
					<div>
						问题描述 求大神帮忙啊,看看这是咋回事 07-30 11:19:09.510: E/MessageQueue-JNI(10893): Exception in MessageQueue callbac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YxWYb.html" rel="bookmark" class="title">2009-11-13 08&colon;37 实现文件读写操作的几种方法</a>
					<div>
						实现文件读写操作的几种方法 下面为实现文件读取数据的代码: //以下为用C语言读取文件 FILE *pfile=fopen(&quot;2.txt&quot;,&quot;r&quot;);      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYBRgrp.html" rel="bookmark" class="title">EMChatService如何手动停止，以及集成了环信自后，应用总是&period;&period;&period;</a>
					<div>
						问题描述 EMChatService如何在程序退出的时候停止,因为目前出现了一个问题,就是在集成了环信之后,应用总是无端的不定时的打开APP的主界面,android.os.Process.killPr ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
